/*
   Copyright (C) 2016 Ignacio Vina (@igvina)

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

#pragma once

#define PLAYER_WIDTH  12
#define PLAYER_HEIGHT 18

// ex. 2 frames (changes every 10 pix)
const int NUMBER_FRAMES =  2;
const int FRAME_CHANGE  = 10;

#ifdef ARDUBOY_2
const unsigned char PLAYER_BITMAP[] PROGMEM = //12,18
{
  0x00, 0x18, 0xff, 0x8e, 0x8c, 0x8c, 0x8c, 0x8c,
  0x8e, 0xff, 0x18, 0x00, 0x08, 0x84, 0x42, 0x7e,
  0xd1, 0x10, 0x10, 0xd1, 0x7e, 0x42, 0x84, 0x18,
  0x00, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00, 0x01,
  0x01, 0x01, 0x01, 0x00,
};

const unsigned char PLAYER_MASK_BITMAP[] PROGMEM = //12,18
{
  0x00, 0x18, 0xff, 0xfe, 0xfc, 0xfc, 0xfc, 0xfc,
  0xfe, 0xff, 0x18, 0x00, 0x08, 0x84, 0xc2, 0xfe,
  0xdf, 0x1f, 0x1f, 0xdf, 0xfe, 0xc2, 0x84, 0x18,
  0x00, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00, 0x01,
  0x01, 0x01, 0x01, 0x00,
};

const unsigned char PLAYER_SHOT_BITMAP[] PROGMEM = //12,18
{
  0x00, 0x18, 0xff, 0x8e, 0x8c, 0x8c, 0x8c, 0x8c,
  0x8e, 0xff, 0x18, 0x00, 0x00, 0x80, 0x40, 0x7e,
  0xd1, 0x10, 0x10, 0xd1, 0x7e, 0x40, 0x80, 0x00,
  0x00, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00, 0x01,
  0x01, 0x01, 0x01, 0x00,
};

const unsigned char PLAYER_SHOT_MASK_BITMAP[] PROGMEM = //12,18
{
  0x00, 0x18, 0xff, 0xfe, 0xfc, 0xfc, 0xfc, 0xfc,
  0xfe, 0xff, 0x18, 0x00, 0x00, 0x80, 0xc0, 0xfe,
  0xdf, 0x1f, 0x1f, 0xdf, 0xfe, 0xc0, 0x80, 0x00,
  0x00, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00, 0x01,
  0x01, 0x01, 0x01, 0x00,
};

const unsigned char PLAYER_HAPPY_BITMAP[] PROGMEM = //12,18
{
  0xc0, 0x18, 0xff, 0x8e, 0xac, 0x8c, 0x8c, 0xac,
  0x8e, 0xff, 0x18, 0xc0, 0x01, 0x82, 0x42, 0x7e,
  0xd1, 0x10, 0x10, 0xd1, 0x7e, 0x42, 0x82, 0x01,
  0x00, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00, 0x01,
  0x01, 0x01, 0x01, 0x00,
};

const unsigned char PLAYER_HAPPY_MASK_BITMAP[] PROGMEM = //12,18
{
  0xc0, 0x18, 0xff, 0xfe, 0xfc, 0xfc, 0xfc, 0xfc,
  0xfe, 0xff, 0x18, 0xc0, 0x01, 0x82, 0xc2, 0xfe,
  0xdf, 0x1f, 0x1f, 0xdf, 0xfe, 0xc2, 0x82, 0x01,
  0x00, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00, 0x01,
  0x01, 0x01, 0x01, 0x00,
};

const unsigned char PLAYER_RIGHT_BITMAP[][36] PROGMEM = //12,18
{{
    0x00, 0x00, 0x18, 0xff, 0x8e, 0xac, 0x8c, 0xac,
    0x8e, 0xff, 0x18, 0x00, 0x00, 0x00, 0xdc, 0x7e,
    0x51, 0x90, 0x10, 0xd1, 0x7e, 0x42, 0x84, 0x08,
    0x00, 0x00, 0x01, 0x01, 0x01, 0x01, 0x00, 0x01,
    0x01, 0x01, 0x01, 0x00,
  },
  {
    0x00, 0x00, 0x18, 0xff, 0x8e, 0xac, 0x8c, 0xac,
    0x8e, 0xff, 0x18, 0x00, 0xcc, 0x42, 0xc2, 0x5e,
    0x71, 0x10, 0x10, 0x31, 0xde, 0x42, 0x44, 0x84,
    0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x01, 0x01, 0x01, 0x01,
  }
};

const unsigned char PLAYER_RIGHT_MASK_BITMAP[][36] PROGMEM = //12,18
{{
    0x00, 0x00, 0x18, 0xff, 0xfe, 0xfc, 0xfc, 0xfc,
    0xfe, 0xff, 0x18, 0x00, 0x00, 0x00, 0xdc, 0xfe,
    0xdf, 0x9f, 0x1f, 0xdf, 0xfe, 0xc2, 0x84, 0x08,
    0x00, 0x00, 0x01, 0x01, 0x01, 0x01, 0x00, 0x01,
    0x01, 0x01, 0x01, 0x00,
  },
  {
    0x00, 0x00, 0x18, 0xff, 0xfe, 0xfc, 0xfc, 0xfc,
    0xfe, 0xff, 0x18, 0x00, 0xcc, 0xc2, 0xc2, 0x5e,
    0x7f, 0x1f, 0x1f, 0x3f, 0xde, 0xc2, 0xc4, 0x84,
    0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x01, 0x01, 0x01, 0x01,
  }
};
#endif

#ifdef GAMEBUINO_META
const uint8_t GB_PLAYER_BITMAP[] = {
12, 18, // width, height
1, // frames
0, 
0, // frame loop
0xf, // transparent color
1, // color mode
0xff, 0x7f, 0xff, 0xff, 0xf7, 0xff, 0xff, 0x77, 0xff, 0xff, 0x77, 0xff, 0xff, 0x77, 0x77, 0x77, 
0x77, 0xff, 0xf7, 0x77, 0x77, 0x77, 0x77, 0x7f, 0xf7, 0x70, 0x00, 0x00, 0x07, 0x7f, 0xff, 0x70, 
0x00, 0x00, 0x07, 0xff, 0xff, 0x70, 0x00, 0x00, 0x07, 0xff, 0xff, 0x77, 0x77, 0x77, 0x77, 0xff, 
0xff, 0xff, 0x70, 0x07, 0xff, 0xff, 0xff, 0x77, 0x00, 0x00, 0x77, 0xff, 0xf7, 0xf7, 0x00, 0x00, 
0x7f, 0x7f, 0x7f, 0xf7, 0x00, 0x00, 0x7f, 0xf7, 0xff, 0xf7, 0x77, 0x77, 0x7f, 0xf7, 0xff, 0xf7, 
0xff, 0xff, 0x7f, 0xff, 0xff, 0x77, 0x7f, 0xf7, 0x77, 0xff, 0xf7, 0x00, 0x7f, 0xf7, 0x00, 0x7f, 
0xf7, 0x77, 0x7f, 0xf7, 0x77, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,};

Image IM_PLAYER_BITMAP(GB_PLAYER_BITMAP);
Image* PLAYER_BITMAP = &IM_PLAYER_BITMAP;
uint8_t* PLAYER_MASK_BITMAP = 0;

const uint8_t GB_PLAYER_SHOT_BITMAP[] = {
12, 18, // width, height
1, // frames
0, 
0, // frame loop
0xf, // transparent color
1, // color mode
0xff, 0x7f, 0xff, 0xff, 0xf7, 0xff, 0xff, 0x77, 0xff, 0xff, 0x77, 0xff, 0xff, 0x77, 0x77, 0x77, 
0x77, 0xff, 0xf7, 0x77, 0x77, 0x77, 0x77, 0x7f, 0xf7, 0x70, 0x00, 0x00, 0x07, 0x7f, 0xff, 0x70, 
0x00, 0x00, 0x07, 0xff, 0xff, 0x70, 0x00, 0x00, 0x07, 0xff, 0xff, 0x77, 0x77, 0x77, 0x77, 0xff, 
0xff, 0xff, 0x70, 0x07, 0xff, 0xff, 0xff, 0xf7, 0x00, 0x00, 0x7f, 0xff, 0xff, 0xf7, 0x00, 0x00, 
0x7f, 0xff, 0xff, 0xf7, 0x00, 0x00, 0x7f, 0xff, 0xff, 0xf7, 0x77, 0x77, 0x7f, 0xff, 0xff, 0xf7, 
0xff, 0xff, 0x7f, 0xff, 0xff, 0x77, 0x7f, 0xf7, 0x77, 0xff, 0xf7, 0x00, 0x7f, 0xf7, 0x00, 0x7f, 
0xf7, 0x77, 0x7f, 0xf7, 0x77, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,};

Image IM_PLAYER_SHOT_BITMAP(GB_PLAYER_SHOT_BITMAP);
Image* PLAYER_SHOT_BITMAP = &IM_PLAYER_SHOT_BITMAP;
uint8_t* PLAYER_SHOT_MASK_BITMAP = 0;

const uint8_t GB_PLAYER_HAPPY_BITMAP[] = {
12, 18, // width, height
1, // frames
0, 
0, // frame loop
0xf, // transparent color
1, // color mode
0xff, 0x7f, 0xff, 0xff, 0xf7, 0xff, 0xff, 0x77, 0xff, 0xff, 0x77, 0xff, 0xff, 0x77, 0x77, 0x77, 
0x77, 0xff, 0xf7, 0x77, 0x77, 0x77, 0x77, 0x7f, 0xf7, 0x70, 0x00, 0x00, 0x07, 0x7f, 0xff, 0x70, 
0x70, 0x07, 0x07, 0xff, 0x7f, 0x70, 0x00, 0x00, 0x07, 0xf7, 0x7f, 0x77, 0x77, 0x77, 0x77, 0xf7, 
0x7f, 0xff, 0x70, 0x07, 0xff, 0xf7, 0xf7, 0x77, 0x00, 0x00, 0x77, 0x7f, 0xff, 0xf7, 0x00, 0x00, 
0x7f, 0xff, 0xff, 0xf7, 0x00, 0x00, 0x7f, 0xff, 0xff, 0xf7, 0x77, 0x77, 0x7f, 0xff, 0xff, 0xf7, 
0xff, 0xff, 0x7f, 0xff, 0xff, 0x77, 0x7f, 0xf7, 0x77, 0xff, 0xf7, 0x00, 0x7f, 0xf7, 0x00, 0x7f, 
0xf7, 0x77, 0x7f, 0xf7, 0x77, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,};

Image IM_PLAYER_HAPPY_BITMAP(GB_PLAYER_HAPPY_BITMAP);
Image* PLAYER_HAPPY_BITMAP = &IM_PLAYER_HAPPY_BITMAP;
uint8_t* PLAYER_HAPPY_MASK_BITMAP = 0;

const uint8_t GB_PLAYER_RIGHT1_BITMAP[] = {
12, 18, // width, height
1, // frames
0, 
0, // frame loop
0xf, // transparent color
1, // color mode
0xff, 0xf7, 0xff, 0xff, 0xf7, 0xff, 0xff, 0xf7, 0x7f, 0xff, 0x77, 0xff, 0xff, 0xf7, 0x77, 0x77, 
0x77, 0xff, 0xff, 0x77, 0x77, 0x77, 0x77, 0x7f, 0xff, 0x77, 0x00, 0x00, 0x07, 0x7f, 0xff, 0xf7, 
0x07, 0x07, 0x07, 0xff, 0xff, 0xf7, 0x00, 0x00, 0x07, 0xff, 0xff, 0xf7, 0x77, 0x77, 0x77, 0xff, 
0xff, 0xff, 0x70, 0x07, 0xff, 0xff, 0xff, 0xf7, 0x00, 0x00, 0x77, 0xff, 0xff, 0x77, 0x00, 0x00, 
0x7f, 0x7f, 0xff, 0x77, 0x00, 0x00, 0x7f, 0xf7, 0xff, 0x77, 0x77, 0x77, 0x7f, 0xff, 0xff, 0xf7, 
0xff, 0xff, 0x7f, 0xff, 0xff, 0x77, 0x7f, 0xf7, 0x77, 0xff, 0xff, 0x70, 0x07, 0xf7, 0x00, 0x7f, 
0xff, 0x77, 0x77, 0xf7, 0x77, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,};

const uint8_t GB_PLAYER_RIGHT2_BITMAP[] = {
12, 18, // width, height
1, // frames
0, 
0, // frame loop
0xf, // transparent color
1, // color mode
0xff, 0xf7, 0xff, 0xff, 0xf7, 0xff, 0xff, 0xf7, 0x7f, 0xff, 0x77, 0xff, 0xff, 0xf7, 0x77, 0x77, 
0x77, 0xff, 0xff, 0x77, 0x77, 0x77, 0x77, 0x7f, 0xff, 0x77, 0x00, 0x00, 0x07, 0x7f, 0xff, 0xf7, 
0x07, 0x07, 0x07, 0xff, 0xff, 0xf7, 0x00, 0x00, 0x07, 0xff, 0xff, 0xf7, 0x77, 0x77, 0x77, 0xff, 
0xff, 0xff, 0x70, 0x07, 0xff, 0xff, 0xf7, 0x77, 0x00, 0x00, 0x77, 0xff, 0x7f, 0xf7, 0x00, 0x00, 
0x7f, 0x77, 0x7f, 0xf7, 0x00, 0x00, 0x7f, 0xff, 0xff, 0xf7, 0x77, 0x77, 0x7f, 0xff, 0xff, 0xff, 
0x7f, 0xf7, 0xff, 0xff, 0x77, 0x77, 0x7f, 0xff, 0x77, 0x7f, 0x70, 0x7f, 0xff, 0xff, 0x70, 0x07, 
0x77, 0x7f, 0xff, 0xff, 0x77, 0x77, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,};

Image IM_PLAYER_RIGHT1_BITMAP(GB_PLAYER_RIGHT1_BITMAP);
Image IM_PLAYER_RIGHT2_BITMAP(GB_PLAYER_RIGHT2_BITMAP);

Image* PLAYER_RIGHT1_BITMAP = &IM_PLAYER_RIGHT1_BITMAP;
Image* PLAYER_RIGHT2_BITMAP = &IM_PLAYER_RIGHT2_BITMAP;

Image* PLAYER_RIGHT_BITMAP[] =
{
  PLAYER_RIGHT1_BITMAP,
  PLAYER_RIGHT2_BITMAP
};

uint8_t *PLAYER_RIGHT_MASK_BITMAP[] =
{
  0,
  0
};
#endif
